from gpiozero import OutputDevice
import time

DIN = OutputDevice(17)
CS = OutputDevice(27)
CLK = OutputDevice(22)

buffer0 = [0x1C, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x1C] #0
buffer1 = [0x18, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x1C] #1
buffer2 = [0x1C, 0x22, 0x22, 0x04, 0x08, 0x10, 0x20, 0x3E] #2
buffer3 = [0x1C, 0x22, 0x02, 0x0C, 0x02, 0x02, 0x22, 0x1C] #3
buffer4 = [0x04, 0x0C, 0x14, 0x24, 0x44, 0x7E, 0x04, 0x04] #4
buffer5 = [0x1C, 0x20, 0x20, 0x3C, 0x02, 0x02, 0x22, 0x1C] #5
buffer6 = [0x1C, 0x22, 0x20, 0x3C, 0x22, 0x22, 0x22, 0x1C] #6
buffer7 = [0x3e, 0x24, 0x04, 0x08, 0x08, 0x08, 0x08, 0x08] #7
buffer8 = [0x1C, 0x22, 0x22, 0x1C, 0x22, 0x22, 0x22, 0x1C] #8
buffer9 = [0x1C, 0x22, 0x22, 0x22, 0x1E, 0x02, 0x22, 0x1C] #9
buffer10 = [0x3C, 0x42, 0xA5, 0x81, 0xA5, 0x99, 0x42, 0x3C] #微笑
buffer11 = [0x3C, 0x42, 0xA5, 0x81, 0xBD, 0x81, 0x42, 0x3C] #中性
buffer12 = [0x3C, 0x42, 0xA5, 0x81, 0x99, 0xA5, 0x42, 0x3C] #悲伤
buffer13 = [0x08, 0x1c, 0x3e, 0x7f, 0x1c, 0x1c, 0x1c, 0x1c] #向上箭头↑
buffer14 = [0x1c, 0x1c, 0x1c, 0x1c, 0x7f, 0x3e, 0x1c, 0x08] #向下箭头↓
buffer15 = [0x10, 0x30, 0x7f, 0xff, 0x7f, 0x30, 0x10, 0x00] #向左箭头←
buffer16 = [0x08, 0x0c, 0xfe, 0xff, 0xfe, 0x0c, 0x08, 0x00] #向右箭头→
buffer17 = [0x00, 0x76, 0x89, 0x81, 0x81, 0x42, 0x24, 0x18] #空❤
buffer18 = [0x00, 0x00, 0x24, 0x7E, 0x7E, 0x3C, 0x18, 0x00] #小❤
buffer19 = [0x00, 0x66, 0xFF, 0xFF, 0xFF, 0x7E, 0x3C, 0x18] #大❤

buffer20 = [buffer0, buffer1, buffer2, buffer3, buffer4, buffer5, buffer6, buffer7, buffer8, buffer9,
            buffer10,buffer11,buffer12,buffer13,buffer14,buffer15,buffer16,buffer17,buffer18,buffer19]

def send_bit(data):
    for bit in range(0,8):
        DIN.value = 0x80 & (data << bit)
        CLK.on()
        CLK.off()
    
def write_Byte(addr,num):
    send_bit(addr)
    send_bit(num)
    CS.on()
    CS.off()
        
def initData():
    write_Byte(0x09,0x00)
    write_Byte(0x0a,0x03)
    write_Byte(0x0b,0x07)
    write_Byte(0x0c,0x01)
    write_Byte(0xff,0x00)

try:
    initData()    
    for n in range(0,20):
        for i in range(0,8):
            write_Byte(i+1,buffer20[n][i])
        time.sleep(1)
except KeyboardInterrupt:
    pass





