#!/usr/bin/env python3
from gpiozero import OutputDevice
from time import sleep

DIN = OutputDevice(13) 
PCLK = OutputDevice(19) 
SCLK = OutputDevice(26) 

segCode = [
	0xc0, 0xf9, 0xa4, 0xb0, 0x99, 
    0x92, 0x82, 0xf8, 0x80, 0x90, 
    0x88, 0x83, 0xc6, 0xa1, 0x86, 
    0x8e, 0x8c, 0xc1, 0x91, 0xc7, 
    ]


def display(data,dp):
    if dp == 1:
        data &= 0x7f
    else:
        data |= 0x80
        
    for bit in range(8):
        DIN.value = 0x80 & (data << bit)
        SCLK.on()
        sleep(0.001)
        SCLK.off()

try:
    while True:
        for code in segCode:
            display(code,2)  
            display(0x0f,0)  
            PCLK.on()
            sleep(0.001)
            PCLK.off()
            print(f"Displaying segCode[{segCode.index(code)}]: 0x{code:02X}")
            sleep(0.5)  

except KeyboardInterrupt:
    pass
