import time
import smbus

BUS = smbus.SMBus(1)

def write_word(addr, data):
    global BLEN
    temp = data
    if BLEN == 1:
        temp |= 0x08
    else:
        temp &= 0xF7
    BUS.write_byte(addr, temp)

def send_command(comm):
    lcd_buf = comm & 0xf0
    lcd_buf |= 0x04
    write_word(LCD_ADDR, lcd_buf)
    time.sleep(0.002)
    lcd_buf &= 0xFB
    write_word(LCD_ADDR, lcd_buf)
    
    lcd_buf = (comm & 0x0F) << 4
    lcd_buf |= 0x04
    write_word(LCD_ADDR, lcd_buf)
    time.sleep(0.002)
    lcd_buf &= 0xFB
    write_word(LCD_ADDR, lcd_buf)
    
def send_data(data):
    lcd_buf = data & 0xf0
    lcd_buf |= 0x05
    write_word(LCD_ADDR, lcd_buf)
    time.sleep(0.002)
    lcd_buf &= 0xFB
    write_word(LCD_ADDR, lcd_buf)
    
    lcd_buf = (data & 0x0F) << 4
    lcd_buf |= 0x05
    write_word(LCD_ADDR, lcd_buf)
    time.sleep(0.002)
    lcd_buf &= 0xFB
    write_word(LCD_ADDR, lcd_buf)

def LCD_Init(addr,b1):
    global LCD_ADDR
    global BLEN
    LCD_ADDR = addr
    BLEN = b1
    try:
        send_command(0x33)
        time.sleep(0.005)
        send_command(0x32)
        time.sleep(0.005)
        send_command(0x28)
        time.sleep(0.005)
        send_command(0x0C)
        time.sleep(0.005)
        send_command(0x01)
        BUS.write_byte(LCD_ADDR, 0x08)
    except:
        return False
    else:
        return True
    
def clear():
    send_command(0x01)
    
def openlight():
    BUS.write_byte(0x27, 0x08)
    BUS.close()
    
def write(lcd_x, lcd_y, lcd_str):
    if lcd_x < 0:
        lcd_x = 0
    if lcd_x > 15:
        lcd_x = 15
    if lcd_y < 0:
        lcd_y = 0
    if lcd_y > 15:
        lcd_y = 15
        
    lcd_addr = 0x80 + 0x40 * lcd_y + lcd_x
    send_command(lcd_addr)
    
    for chr in lcd_str:
        send_data(ord(chr))
        
if __name__ == '__main__':
    LCD_Init(0X27,1)
    write(4, 0, 'Hello')
    write(7, 1, 'world!')    